searchData={"items":[{"type":"module","doc":"","title":"nats","ref":"nats.html"},{"type":"opaque","doc":"","title":"nats.conn/0","ref":"nats.html#t:conn/0"},{"type":"function","doc":"Connects to a NATS server or cluster using the specified options.\nThis function supports the v1 options format, including a list of servers.","title":"nats.connect/1","ref":"nats.html#connect/1"},{"type":"function","doc":"Connects to a NATS server or cluster using the specified server information and v0 options.\nSupports connecting to a single server or a list of servers.","title":"nats.connect/2","ref":"nats.html#connect/2"},{"type":"function","doc":"Connects to a NATS server at the given host and port with specified v0 options.","title":"nats.connect/3","ref":"nats.html#connect/3"},{"type":"function","doc":"Disconnects the client from the NATS server.","title":"nats.disconnect/1","ref":"nats.html#disconnect/1"},{"type":"function","doc":"Dumps the current subscriptions for debugging purposes.","title":"nats.dump_subs/1","ref":"nats.html#dump_subs/1"},{"type":"type","doc":"","title":"nats.endpoint/0","ref":"nats.html#t:endpoint/0"},{"type":"function","doc":"Creates an endpoint record for use within a service.","title":"nats.endpoint/2","ref":"nats.html#endpoint/2"},{"type":"function","doc":"Flushes the pending messages to the NATS server.","title":"nats.flush/1","ref":"nats.html#flush/1"},{"type":"function","doc":"Return true is the connection process is alive","title":"nats.is_alive/1","ref":"nats.html#is_alive/1"},{"type":"function","doc":"Checks if the client is ready to send and receive messages.","title":"nats.is_ready/1","ref":"nats.html#is_ready/1"},{"type":"type","doc":"","title":"nats.nats_host/0","ref":"nats.html#t:nats_host/0"},{"type":"type","doc":"","title":"nats.nats_server/0","ref":"nats.html#t:nats_server/0"},{"type":"type","doc":"","title":"nats.nats_server_info/0","ref":"nats.html#t:nats_server_info/0"},{"type":"type","doc":"","title":"nats.nats_server_opts/0","ref":"nats.html#t:nats_server_opts/0"},{"type":"type","doc":"","title":"nats.notify_fun/0","ref":"nats.html#t:notify_fun/0"},{"type":"function","doc":"Retrieves the remote peer address of the connection.","title":"nats.peername/1","ref":"nats.html#peername/1"},{"type":"function","doc":"Publishes a message with no payload and default options to the specified subject.","title":"nats.pub/2","ref":"nats.html#pub/2"},{"type":"function","doc":"Publishes a message with either no payload and specified options to the specified subject, or\nwith the specified payload and default options to the specified subject.","title":"nats.pub/3","ref":"nats.html#pub/3"},{"type":"function","doc":"Publishes a message with the specified payload and options to the specified subject.","title":"nats.pub/4","ref":"nats.html#pub/4"},{"type":"function","doc":"Sends a request message and waits for a single reply.","title":"nats.request/4","ref":"nats.html#request/4"},{"type":"function","doc":"Generates a random topic ID.","title":"nats.rnd_topic_id/0","ref":"nats.html#rnd_topic_id/0"},{"type":"function","doc":"Registers a service with the NATS server.","title":"nats.serve/2","ref":"nats.html#serve/2"},{"type":"function","doc":"Retrieves the server information received during connection.","title":"nats.server_info/1","ref":"nats.html#server_info/1"},{"type":"type","doc":"","title":"nats.service/0","ref":"nats.html#t:service/0"},{"type":"function","doc":"Creates a service record for use with `serve/2`.","title":"nats.service/4","ref":"nats.html#service/4"},{"type":"function","doc":"Sends a reply to a service request.","title":"nats.service_reply/2","ref":"nats.html#service_reply/2"},{"type":"function","doc":"Sends a reply with headers to a service request.","title":"nats.service_reply/3","ref":"nats.html#service_reply/3"},{"type":"opaque","doc":"","title":"nats.sid/0","ref":"nats.html#t:sid/0"},{"type":"type","doc":"","title":"nats.socket_opts/0","ref":"nats.html#t:socket_opts/0"},{"type":"function","doc":"Retrieves the local socket address of the connection.","title":"nats.sockname/1","ref":"nats.html#sockname/1"},{"type":"function","doc":"Subscribes to the specified subject with default options.","title":"nats.sub/2","ref":"nats.html#sub/2"},{"type":"function","doc":"Subscribes to the specified subject with the given options.","title":"nats.sub/3","ref":"nats.html#sub/3"},{"type":"function","doc":"Unsubscribes from the specified subscription reference.","title":"nats.unsub/2","ref":"nats.html#unsub/2"},{"type":"function","doc":"Unsubscribes from the specified subscription reference with options (e.g., max messages).","title":"nats.unsub/3","ref":"nats.html#unsub/3"},{"type":"type","doc":"","title":"nats.v0_opts/0","ref":"nats.html#t:v0_opts/0"},{"type":"type","doc":"","title":"nats.v1_opts/0","ref":"nats.html#t:v1_opts/0"},{"type":"module","doc":"","title":"nats_consumer","ref":"nats_consumer.html"},{"type":"function","doc":"","title":"nats_consumer.ack_msg/4","ref":"nats_consumer.html#ack_msg/4"},{"type":"function","doc":"","title":"nats_consumer.create/2","ref":"nats_consumer.html#create/2"},{"type":"function","doc":"","title":"nats_consumer.create/3","ref":"nats_consumer.html#create/3"},{"type":"function","doc":"","title":"nats_consumer.create/4","ref":"nats_consumer.html#create/4"},{"type":"function","doc":"","title":"nats_consumer.create/5","ref":"nats_consumer.html#create/5"},{"type":"function","doc":"","title":"nats_consumer.delete/2","ref":"nats_consumer.html#delete/2"},{"type":"function","doc":"","title":"nats_consumer.delete/3","ref":"nats_consumer.html#delete/3"},{"type":"function","doc":"","title":"nats_consumer.delete/4","ref":"nats_consumer.html#delete/4"},{"type":"function","doc":"","title":"nats_consumer.get/2","ref":"nats_consumer.html#get/2"},{"type":"function","doc":"","title":"nats_consumer.get/3","ref":"nats_consumer.html#get/3"},{"type":"function","doc":"","title":"nats_consumer.get/4","ref":"nats_consumer.html#get/4"},{"type":"function","doc":"","title":"nats_consumer.msg_next/3","ref":"nats_consumer.html#msg_next/3"},{"type":"function","doc":"","title":"nats_consumer.msg_next/5","ref":"nats_consumer.html#msg_next/5"},{"type":"function","doc":"","title":"nats_consumer.msg_next/6","ref":"nats_consumer.html#msg_next/6"},{"type":"function","doc":"","title":"nats_consumer.subscribe/3","ref":"nats_consumer.html#subscribe/3"},{"type":"function","doc":"","title":"nats_consumer.subscribe/4","ref":"nats_consumer.html#subscribe/4"},{"type":"function","doc":"","title":"nats_consumer.types/1","ref":"nats_consumer.html#types/1"},{"type":"function","doc":"","title":"nats_consumer.unsubscribe/3","ref":"nats_consumer.html#unsubscribe/3"},{"type":"function","doc":"","title":"nats_consumer.unsubscribe/4","ref":"nats_consumer.html#unsubscribe/4"},{"type":"module","doc":"","title":"nats_kv","ref":"nats_kv.html"},{"type":"type","doc":"","title":"nats_kv.config/0","ref":"nats_kv.html#t:config/0"},{"type":"function","doc":"Equivalent to  create(Conn, Bucket, Key, Value, #{}) .","title":"nats_kv.create/4","ref":"nats_kv.html#create/4"},{"type":"function","doc":"Creates a key/value pair if the key does not exist with additional options.\n\nSee `create/4` for details on `Conn`, `Bucket`, `Key`, and `Value`.\n`Opts` allows specifying options, including `return_existing` which, if true,\nwill return `{error, {exists, OldObj}}` where `OldObj` is the existing message details.\nReturns `{ok, map()}` or `{error, Reason}`.","title":"nats_kv.create/5","ref":"nats_kv.html#create/5"},{"type":"function","doc":"Equivalent to  create_bucket(Conn, #{bucket => Bucket}, #{}) .","title":"nats_kv.create_bucket/2","ref":"nats_kv.html#create_bucket/2"},{"type":"function","doc":"Creates a KeyValue store bucket with the specified configuration and options.\n\n`Config` is a map containing the bucket configuration (see `t:config/0`).\n`Opts` allows specifying options for the underlying NATS request.\nReturns `{ok, map()}` on success or `{error, Reason}` on failure.","title":"nats_kv.create_bucket/3","ref":"nats_kv.html#create_bucket/3"},{"type":"function","doc":"Creates a KeyValue store bucket with the specified bucket name, configuration, and options.\n\nThis is an alternative way to specify the bucket name alongside the configuration map.\nReturns `{ok, map()}` on success or `{error, Reason}` on failure.\n\nEquivalent to [`create_bucket(Conn, Config#{bucket => Bucket}, Opts)`](`create_bucket/3`).","title":"nats_kv.create_bucket/4","ref":"nats_kv.html#create_bucket/4"},{"type":"function","doc":"Equivalent to  delete(Conn, Bucket, Key, #{}) .","title":"nats_kv.delete/3","ref":"nats_kv.html#delete/3"},{"type":"function","doc":"Deletes a key by placing a delete marker with additional options.\n\nThis is a non-destructive operation; all previous revisions are kept.\nA history of a deleted key can still be retrieved using `get/4,5` with a specific revision\nor by using a watcher without the `ignore_deletes` option.\n\n`Opts` can include:\n- `revision`: An integer sequence number. The delete will only succeed if the latest\n  revision matches this number (conditional delete).\n- `purge`: If `true`, performs a purge instead of a regular delete (see `purge/3`).\nReturns `{ok, map()}` or `{error, Reason}`.","title":"nats_kv.delete/4","ref":"nats_kv.html#delete/4"},{"type":"function","doc":"Equivalent to  delete_bucket(Conn, Bucket, #{}) .","title":"nats_kv.delete_bucket/2","ref":"nats_kv.html#delete_bucket/2"},{"type":"function","doc":"Deletes a KeyValue store bucket with the specified options.\n\nAllows specifying options for the underlying NATS request.\nReturns `{ok, map()}` on success or `{error, Reason}` on failure.","title":"nats_kv.delete_bucket/3","ref":"nats_kv.html#delete_bucket/3"},{"type":"function","doc":"Retrieves the latest value for a key.\n\nEquivalent to [`get(Conn, Bucket, Key, last, #{})`](`get/5`).","title":"nats_kv.get/3","ref":"nats_kv.html#get/3"},{"type":"function","doc":"Retrieves a specific revision of a key by sequence number, or the latest value with options.\n\n- `get(Conn, Bucket, Key, SeqNo)`: Retrieves the value at a specific `SeqNo` or the `last` revision.\n- `get(Conn, Bucket, Key, Opts)`: Retrieves the latest value with additional `Opts`.\n\nIf the key does not exist, an error indicating \"Message Not Found\" will be returned.\nIf the key has been deleted, `{deleted, map()}` is returned.\nOtherwise, `{ok, binary()}` is returned with the key's value.","title":"nats_kv.get/4","ref":"nats_kv.html#get/4"},{"type":"function","doc":"Retrieves a specific revision of a key by sequence number with additional options.\n\nThis is the most general `get` function.\n`SeqNo` can be an integer revision number or the atom `last`.\n`Opts` allows specifying options for the underlying NATS request.\n\nIf the key does not exist or the specific revision is not found, an error indicating \"Message Not Found\" will be returned.\nIf the key at the specified revision has a delete or purge marker, `{deleted, map()}` is returned.\nOtherwise, `{ok, map()}` is returned containing the message details.","title":"nats_kv.get/5","ref":"nats_kv.html#get/5"},{"type":"function","doc":"Equivalent to  get_bucket(Conn, Bucket, #{}) .","title":"nats_kv.get_bucket/2","ref":"nats_kv.html#get_bucket/2"},{"type":"function","doc":"Retrieves the configuration of a KeyValue store bucket with additional options.\n\nAllows specifying options for the underlying NATS request.\nReturns `{ok, Config}` or `{error, Reason}`.","title":"nats_kv.get_bucket/3","ref":"nats_kv.html#get_bucket/3"},{"type":"function","doc":"","title":"nats_kv.get_msg/4","ref":"nats_kv.html#get_msg/4"},{"type":"function","doc":"Equivalent to  list_keys(Conn, Bucket, WatchOpts, #{}) .","title":"nats_kv.list_keys/3","ref":"nats_kv.html#list_keys/3"},{"type":"function","doc":"Retrieves all keys from the key value store with additional options.\n\nThis is a convenience function equivalent to calling `select_keys/4` with `Keys` set to `~\">\"`.\n`WatchOpts` is a map of options for the watcher behavior (e.g., `include_history`, `meta_only`).\nNote that `ignore_deletes` is implicitly set to `true` for this function.\n`Opts` allows specifying options for the underlying NATS request.\nReturns `{ok, List}` or `{error, Reason}`.","title":"nats_kv.list_keys/4","ref":"nats_kv.html#list_keys/4"},{"type":"function","doc":"Purges a key by placing a delete marker and removing all previous revisions.\n\nThis is a destructive operation. Only the latest revision (the purge marker)\nwill be preserved.\nReturns `{ok, map()}` containing the publish response details for the purge marker\nor `{error, Reason}` on failure.","title":"nats_kv.purge/3","ref":"nats_kv.html#purge/3"},{"type":"function","doc":"Purges a key with additional options.\n\nSee `purge/3` for details on `Conn`, `Bucket`, and `Key`.\n`Opts` can include:\n- `revision`: An integer sequence number. The purge will only succeed if the latest\n  revision matches this number (conditional purge).\nReturns `{ok, map()}` or `{error, Reason}`.","title":"nats_kv.purge/4","ref":"nats_kv.html#purge/4"},{"type":"function","doc":"Puts a new value for a key into the store.\n\nIf the key does not exist, it will be created. If the key exists, the value will be updated.\nA key must consist of alphanumeric characters, dashes, underscores, equal signs, and dots.\nReturns `{ok, map()}` containing the publish response details or `{error, Reason}` on failure.","title":"nats_kv.put/4","ref":"nats_kv.html#put/4"},{"type":"function","doc":"Equivalent to  select_keys(Conn, Bucket, Keys, WatchOpts, #{}) .","title":"nats_kv.select_keys/4","ref":"nats_kv.html#select_keys/4"},{"type":"function","doc":"Retrieves selected keys from the key value store with additional options.\n\nThis function starts a temporary watcher process to fetch the current values\nfor keys matching the `Keys` pattern(s). It waits for the initial values\nand then stops the watcher.\n`Keys` can be a single binary subject or a list of binary subjects, potentially containing wildcards.\n`WatchOpts` is a map of options for the watcher behavior (e.g., `include_history`, `meta_only`).\nNote that `ignore_deletes` is implicitly set to `true` for this function.\n`Opts` allows specifying options for the underlying NATS request.\n\nReturns `{ok, List}` where `List` is a list of keys (binary()) or key-value pairs ({binary(), binary()}),\nor `{error, Reason}` on failure.","title":"nats_kv.select_keys/5","ref":"nats_kv.html#select_keys/5"},{"type":"function","doc":"Updates the value for a key if the latest revision matches the provided sequence number.\n\nThis function performs a conditional update. If the current latest revision\nof the key does not match `SeqNo`, the update will fail with an error\nindicating a wrong last sequence.\nReturns `{ok, map()}` containing the publish response details or `{error, Reason}` on failure.","title":"nats_kv.update/5","ref":"nats_kv.html#update/5"},{"type":"function","doc":"Equivalent to  update_bucket(Conn, #{bucket => Bucket}, #{}) .","title":"nats_kv.update_bucket/2","ref":"nats_kv.html#update_bucket/2"},{"type":"function","doc":"Updates an existing KeyValue store bucket with the specified configuration and options.\n\n`Config` is a map containing the bucket configuration (see `t:config/0`).\n`Opts` allows specifying options for the underlying NATS request.\nReturns `{ok, map()}` on success or `{error, Reason}` on failure.","title":"nats_kv.update_bucket/3","ref":"nats_kv.html#update_bucket/3"},{"type":"function","doc":"Updates an existing KeyValue store bucket with the specified bucket name, configuration, and options.\n\nThis is an alternative way to specify the bucket name alongside the configuration map.\nReturns `{ok, map()}` on success or `{error, Reason}` on failure.\n\nEquivalent to [`update_bucket(Conn, Config#{bucket => Bucket}, Opts)`](`update_bucket/3`).","title":"nats_kv.update_bucket/4","ref":"nats_kv.html#update_bucket/4"},{"type":"function","doc":"Starts a watcher process that monitors updates to keys matching the given `Keys` pattern(s).\n\n`Keys` can be a single binary subject or a list of binary subjects, potentially containing wildcards.\n`WatchOpts` is a map of options for the watcher behavior (e.g., `include_history`, `ignore_deletes`, `updates_only`, `meta_only`, `resume_from_revision`).\n`Opts` allows specifying options for the underlying NATS request.\n\nThe watcher process will send messages to the calling process's mailbox.\nReturns `{ok, Pid}` of the watcher process or `{error, Reason}` on failure.","title":"nats_kv.watch/5","ref":"nats_kv.html#watch/5"},{"type":"function","doc":"Starts a watcher process with additional start options for the watcher process.\n\nSee `watch/5` for details on `Conn`, `Bucket`, `Keys`, `WatchOpts`, and `Opts`.\n`StartOpts` are options passed to `proc_lib:spawn_opt/4` when starting the watcher process.\nReturns `{ok, Pid}` or `{error, Reason}`.","title":"nats_kv.watch/6","ref":"nats_kv.html#watch/6"},{"type":"function","doc":"Starts a watcher process that monitors all updates in the bucket.\n\nThis is a convenience function equivalent to calling `watch/5` with `Keys` set to `~\">\"`.\n`WatchOpts` and `Opts` are as described in `watch/5`.\nReturns `{ok, Pid}` or `{error, Reason}`.","title":"nats_kv.watch_all/4","ref":"nats_kv.html#watch_all/4"},{"type":"function","doc":"Starts a watcher process that monitors all updates in the bucket with additional start options.\n\nSee `watch_all/4` for details on `Conn`, `Bucket`, `WatchOpts`, and `Opts`.\n`StartOpts` are options passed to `proc_lib:spawn_opt/4`.\nReturns `{ok, Pid}` or `{error, Reason}`.","title":"nats_kv.watch_all/5","ref":"nats_kv.html#watch_all/5"},{"type":"module","doc":"","title":"nats_pull_consumer","ref":"nats_pull_consumer.html"},{"type":"function","doc":"","title":"nats_pull_consumer.code_change/3","ref":"nats_pull_consumer.html#code_change/3"},{"type":"function","doc":"","title":"nats_pull_consumer.handle_call/3","ref":"nats_pull_consumer.html#handle_call/3"},{"type":"function","doc":"","title":"nats_pull_consumer.handle_cast/2","ref":"nats_pull_consumer.html#handle_cast/2"},{"type":"function","doc":"","title":"nats_pull_consumer.handle_info/2","ref":"nats_pull_consumer.html#handle_info/2"},{"type":"function","doc":"","title":"nats_pull_consumer.init/1","ref":"nats_pull_consumer.html#init/1"},{"type":"function","doc":"","title":"nats_pull_consumer.start_link/6","ref":"nats_pull_consumer.html#start_link/6"},{"type":"function","doc":"","title":"nats_pull_consumer.start_link/7","ref":"nats_pull_consumer.html#start_link/7"},{"type":"function","doc":"","title":"nats_pull_consumer.stop/1","ref":"nats_pull_consumer.html#stop/1"},{"type":"function","doc":"","title":"nats_pull_consumer.terminate/2","ref":"nats_pull_consumer.html#terminate/2"},{"type":"module","doc":"","title":"nats_service","ref":"nats_service.html"},{"type":"function","doc":"","title":"nats_service.reply/2","ref":"nats_service.html#reply/2"},{"type":"function","doc":"","title":"nats_service.reply/3","ref":"nats_service.html#reply/3"},{"type":"function","doc":"","title":"nats_service.serve/2","ref":"nats_service.html#serve/2"},{"type":"module","doc":"","title":"nats_stream","ref":"nats_stream.html"},{"type":"function","doc":"","title":"nats_stream.create/3","ref":"nats_stream.html#create/3"},{"type":"function","doc":"","title":"nats_stream.create/4","ref":"nats_stream.html#create/4"},{"type":"function","doc":"","title":"nats_stream.delete/2","ref":"nats_stream.html#delete/2"},{"type":"function","doc":"","title":"nats_stream.delete/3","ref":"nats_stream.html#delete/3"},{"type":"type","doc":"ExternalStream allows you to qualify access to a stream source in another account.","title":"nats_stream.external_stream/0","ref":"nats_stream.html#t:external_stream/0"},{"type":"function","doc":"","title":"nats_stream.get/2","ref":"nats_stream.html#get/2"},{"type":"function","doc":"","title":"nats_stream.get/3","ref":"nats_stream.html#get/3"},{"type":"function","doc":"","title":"nats_stream.list/1","ref":"nats_stream.html#list/1"},{"type":"function","doc":"","title":"nats_stream.list/2","ref":"nats_stream.html#list/2"},{"type":"function","doc":"","title":"nats_stream.list/3","ref":"nats_stream.html#list/3"},{"type":"function","doc":"","title":"nats_stream.msg_delete/3","ref":"nats_stream.html#msg_delete/3"},{"type":"function","doc":"","title":"nats_stream.msg_delete/4","ref":"nats_stream.html#msg_delete/4"},{"type":"function","doc":"","title":"nats_stream.msg_delete/5","ref":"nats_stream.html#msg_delete/5"},{"type":"function","doc":"","title":"nats_stream.msg_get/3","ref":"nats_stream.html#msg_get/3"},{"type":"function","doc":"","title":"nats_stream.msg_get/4","ref":"nats_stream.html#msg_get/4"},{"type":"function","doc":"","title":"nats_stream.names/1","ref":"nats_stream.html#names/1"},{"type":"function","doc":"","title":"nats_stream.names/2","ref":"nats_stream.html#names/2"},{"type":"function","doc":"","title":"nats_stream.names/3","ref":"nats_stream.html#names/3"},{"type":"type","doc":"Placement is used to guide placement of streams in clustered JetStream.","title":"nats_stream.placement/0","ref":"nats_stream.html#t:placement/0"},{"type":"function","doc":"","title":"nats_stream.purge/2","ref":"nats_stream.html#purge/2"},{"type":"function","doc":"","title":"nats_stream.purge/3","ref":"nats_stream.html#purge/3"},{"type":"function","doc":"","title":"nats_stream.purge/4","ref":"nats_stream.html#purge/4"},{"type":"type","doc":"RePublish is for republishing messages once committed to a stream. The\noriginal subject is remapped from the subject pattern to the destination\npattern.","title":"nats_stream.republish/0","ref":"nats_stream.html#t:republish/0"},{"type":"type","doc":"StreamSource dictates how streams can source from other streams.","title":"nats_stream.stream_source/0","ref":"nats_stream.html#t:stream_source/0"},{"type":"type","doc":"SubjectTransformConfig is for applying a subject transform (to matching messages) before doing anything else when a new message is received.","title":"nats_stream.subject_transform_config/0","ref":"nats_stream.html#t:subject_transform_config/0"},{"type":"function","doc":"","title":"nats_stream.types/1","ref":"nats_stream.html#types/1"},{"type":"function","doc":"","title":"nats_stream.update/3","ref":"nats_stream.html#update/3"},{"type":"extras","doc":"nats\n=====\n\nErlang NATS.io client library.\n\nBuild\n-----\n\n    $ rebar3 compile\n\nUsage\n-----\n\n```\napplication:ensure_all_started([enats]),\n\n{ok, C} = nats:connect({127,0,0,1}, 4222, #{verbose => false}),\nreceive {C, ready} -> ok end,\n\n{ok, Sid} = nats:sub(C, ~\"foo.*\"),\n\nnats:pub(C, ~\"foo.bar\", ~\"My payload\"),\n\nreceive\n    {C, Sid, {msg, ~\"foo.bar\", Body, _}} ->\n        io:format(\"Got NATS Msg: ~0tp~n\", [Body]),\n        ok\nafter 1000 ->\n        throw(did_not_receive_a_msg)\nend.\n```\n\nAuthentication\n--------------\n\n```\n# with user and password\n{ok, C} = nats:connect({127,0,0,1}, 4222, #{user => ~\"myname\", pass => ~\"password\", auth_required => true}).\n\n# with token\n{ok, C} = nats:connect({127,0,0,1}, 4222, #{token => ~\"secret\", auth_required => true}).\n\n# with an nkey seed\n{ok, C} = nats:connect({127,0,0,1}, 4222, #{nkey_seed => ~\"SUAM...\", auth_required => true}).\n\n# with decentralized user credentials (JWT)\n{ok, C} = nats:connect({127,0,0,1}, 4222, #{nkey_seed => ~\"SUAM...\", jwt => ~\"eyJ0eX...\", auth_required => true}).\n\n# connect to NGS with JWT\n{ok, C} = nats:connect(\"connect.ngs.global\", 4222, #{tls_required => true, tls_opts => [{verify, verify_peer}, {cacerts, public_key:cacerts_get()}], nkey_seed => ~\"SUAM...\", jwt => ~\"eyJ0eX...\", auth_required => true}).\n```","title":"nats","ref":"readme.html"},{"type":"extras","doc":"# Apache License\nVersion 2.0, January 2004\n\nhttp://www.apache.org/licenses/\n\nTERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION","title":"Apache License","ref":"license.html"},{"type":"extras","doc":"\"License\" shall mean the terms and conditions for use, reproduction, and\ndistribution as defined by Sections 1 through 9 of this document.\n\n\"Licensor\" shall mean the copyright owner or entity authorized by the copyright\nowner that is granting the License.\n\n\"Legal Entity\" shall mean the union of the acting entity and all other entities\nthat control, are controlled by, or are under common control with that entity.\nFor the purposes of this definition, \"control\" means (i) the power, direct or\nindirect, to cause the direction or management of such entity, whether by\ncontract or otherwise, or (ii) ownership of fifty percent (50%) or more of the\noutstanding shares, or (iii) beneficial ownership of such entity.\n\n\"You\" (or \"Your\") shall mean an individual or Legal Entity exercising\npermissions granted by this License.\n\n\"Source\" form shall mean the preferred form for making modifications, including\nbut not limited to software source code, documentation source, and configuration\nfiles.\n\n\"Object\" form shall mean any form resulting from mechanical transformation or\ntranslation of a Source form, including but not limited to compiled object code,\ngenerated documentation, and conversions to other media types.\n\n\"Work\" shall mean the work of authorship, whether in Source or Object form, made\navailable under the License, as indicated by a copyright notice that is included\nin or attached to the work (an example is provided in the Appendix below).\n\n\"Derivative Works\" shall mean any work, whether in Source or Object form, that\nis based on (or derived from) the Work and for which the editorial revisions,\nannotations, elaborations, or other modifications represent, as a whole, an\noriginal work of authorship. For the purposes of this License, Derivative Works\nshall not include works that remain separable from, or merely link (or bind by\nname) to the interfaces of, the Work and Derivative Works thereof.\n\n\"Contribution\" shall mean any work of authorship, including the original version\nof the Work and any modifications or additions to that Work or Derivative Works\nthereof, that is intentionally submitted to Licensor for inclusion in the Work\nby the copyright owner or by an individual or Legal Entity authorized to submit\non behalf of the copyright owner. For the purposes of this definition,\n\"submitted\" means any form of electronic, verbal, or written communication sent\nto the Licensor or its representatives, including but not limited to\ncommunication on electronic mailing lists, source code control systems, and\nissue tracking systems that are managed by, or on behalf of, the Licensor for\nthe purpose of discussing and improving the Work, but excluding communication\nthat is conspicuously marked or otherwise designated in writing by the copyright\nowner as \"Not a Contribution.\"\n\n\"Contributor\" shall mean Licensor and any individual or Legal Entity on behalf\nof whom a Contribution has been received by Licensor and subsequently\nincorporated within the Work.","title":"1. Definitions. - Apache License","ref":"license.html#1-definitions"},{"type":"extras","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable copyright license to reproduce, prepare Derivative Works of,\npublicly display, publicly perform, sublicense, and distribute the Work and such\nDerivative Works in Source or Object form.","title":"2. Grant of Copyright License. - Apache License","ref":"license.html#2-grant-of-copyright-license"},{"type":"extras","doc":"Subject to the terms and conditions of this License, each Contributor hereby\ngrants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free,\nirrevocable (except as stated in this section) patent license to make, have\nmade, use, offer to sell, sell, import, and otherwise transfer the Work, where\nsuch license applies only to those patent claims licensable by such Contributor\nthat are necessarily infringed by their Contribution(s) alone or by combination\nof their Contribution(s) with the Work to which such Contribution(s) was\nsubmitted. If You institute patent litigation against any entity (including a\ncross-claim or counterclaim in a lawsuit) alleging that the Work or a\nContribution incorporated within the Work constitutes direct or contributory\npatent infringement, then any patent licenses granted to You under this License\nfor that Work shall terminate as of the date such litigation is filed.","title":"3. Grant of Patent License. - Apache License","ref":"license.html#3-grant-of-patent-license"},{"type":"extras","doc":"You may reproduce and distribute copies of the Work or Derivative Works thereof\nin any medium, with or without modifications, and in Source or Object form,\nprovided that You meet the following conditions:\n\n1. You must give any other recipients of the Work or Derivative Works a copy of\n   this License; and\n\n2. You must cause any modified files to carry prominent notices stating that\n   You changed the files; and\n\n3. You must retain, in the Source form of any Derivative Works that You\n   distribute, all copyright, patent, trademark, and attribution notices from\n   the Source form of the Work, excluding those notices that do not pertain to\n   any part of the Derivative Works; and\n\n4. If the Work includes a \"NOTICE\" text file as part of its distribution, then\n   any Derivative Works that You distribute must include a readable copy of the\n   attribution notices contained within such NOTICE file, excluding those\n   notices that do not pertain to any part of the Derivative Works, in at least\n   one of the following places: within a NOTICE text file distributed as part\n   of the Derivative Works; within the Source form or documentation, if\n   provided along with the Derivative Works; or, within a display generated by\n   the Derivative Works, if and wherever such third-party notices normally\n   appear. The contents of the NOTICE file are for informational purposes only\n   and do not modify the License. You may add Your own attribution notices\n   within Derivative Works that You distribute, alongside or as an addendum to\n   the NOTICE text from the Work, provided that such additional attribution\n   notices cannot be construed as modifying the License.\n\nYou may add Your own copyright statement to Your modifications and may provide\nadditional or different license terms and conditions for use, reproduction, or\ndistribution of Your modifications, or for any such Derivative Works as a whole,\nprovided Your use, reproduction, and distribution of the Work otherwise complies\nwith the conditions stated in this License.","title":"4. Redistribution. - Apache License","ref":"license.html#4-redistribution"},{"type":"extras","doc":"Unless You explicitly state otherwise, any Contribution intentionally submitted\nfor inclusion in the Work by You to the Licensor shall be under the terms and\nconditions of this License, without any additional terms or conditions.\nNotwithstanding the above, nothing herein shall supersede or modify the terms of\nany separate license agreement you may have executed with Licensor regarding\nsuch Contributions.","title":"5. Submission of Contributions. - Apache License","ref":"license.html#5-submission-of-contributions"},{"type":"extras","doc":"This License does not grant permission to use the trade names, trademarks,\nservice marks, or product names of the Licensor, except as required for\nreasonable and customary use in describing the origin of the Work and\nreproducing the content of the NOTICE file.","title":"6. Trademarks. - Apache License","ref":"license.html#6-trademarks"},{"type":"extras","doc":"Unless required by applicable law or agreed to in writing, Licensor provides the\nWork (and each Contributor provides its Contributions) on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied,\nincluding, without limitation, any warranties or conditions of TITLE, NON-\nINFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are\nsolely responsible for determining the appropriateness of using or\nredistributing the Work and assume any risks associated with Your exercise of\npermissions under this License.","title":"7. Disclaimer of Warranty. - Apache License","ref":"license.html#7-disclaimer-of-warranty"},{"type":"extras","doc":"In no event and under no legal theory, whether in tort (including negligence),\ncontract, or otherwise, unless required by applicable law (such as deliberate\nand grossly negligent acts) or agreed to in writing, shall any Contributor be\nliable to You for damages, including any direct, indirect, special, incidental,\nor consequential damages of any character arising as a result of this License or\nout of the use or inability to use the Work (including but not limited to\ndamages for loss of goodwill, work stoppage, computer failure or malfunction, or\nany and all other commercial damages or losses), even if such Contributor has\nbeen advised of the possibility of such damages.","title":"8. Limitation of Liability. - Apache License","ref":"license.html#8-limitation-of-liability"},{"type":"extras","doc":"While redistributing the Work or Derivative Works thereof, You may choose to\noffer, and charge a fee for, acceptance of support, warranty, indemnity, or\nother liability obligations and/or rights consistent with this License. However,\nin accepting such obligations, You may act only on Your own behalf and on Your\nsole responsibility, not on behalf of any other Contributor, and only if You\nagree to indemnify, defend, and hold each Contributor harmless for any liability\nincurred by, or claims asserted against, such Contributor by reason of your\naccepting any such warranty or additional liability.\n\nEND OF TERMS AND CONDITIONS\n\nCopyright 2024, Andreas Schultz  .\n\nLicensed under the Apache License, Version 2.0 (the \"License\");\nyou may not use this file except in compliance with the License.\nYou may obtain a copy of the License at\n\nhttp://www.apache.org/licenses/LICENSE-2.0\n\nUnless required by applicable law or agreed to in writing, software\ndistributed under the License is distributed on an \"AS IS\" BASIS,\nWITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.\nSee the License for the specific language governing permissions and\nlimitations under the License.","title":"9. Accepting Warranty or Additional Liability. - Apache License","ref":"license.html#9-accepting-warranty-or-additional-liability"}],"proglang":"erlang","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.1"}}